package com.zksy.controller.info;

import cn.hutool.core.date.DateTime;
import com.zksy.info.domain.EAdminLicenseInfo;
import com.zksy.info.domain.EGas;
import com.zksy.info.service.EAdminLicenseInfoService;
import com.zksy.info.service.EGasService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 燃气控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/egas")
@Api(tags = "燃气信息",description = "燃气信息desc")
public class EGasController {
    @Autowired
    private EGasService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "燃气信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String company,String userInfo){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, company,userInfo));
    }
    @GetMapping("/getEGasList")
    @ApiOperation(value = "燃气信息查询")
    public AjaxResult getEGasList(String company,String userInfo){
        return AjaxResult.success(service.getEGasList(company,userInfo));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询燃气信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "燃气信息保存")
    public AjaxResult save(@RequestBody EGas egas) {
        return service.save(egas) ? AjaxResult.success(egas) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "燃气信息修改")
    public AjaxResult update(@RequestBody EGas egas) {
        egas.setUpdateTime(LocalDateTime.now());
        return service.updateById(egas) ? AjaxResult.success(egas) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "燃气信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, EGas.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String company,String userInfo) {
        ExcelExportUtil.exportExcel(response,service.getEGasList(company,userInfo), EGas.class, "燃气信息","燃气信息");
    }

}
